{#- ----------------------------------------------------------------------- -#}
{#-  GLOBAL VARIABLES                                                       -#}
{#- ----------------------------------------------------------------------- -#}

{#- this global namespace stack will be used to pass vars from macros defined here -#}
{#- to their callers  -#}
{%- set global_ns = namespace(description="for_object_creation") -%}
{%- set global_ns.var_stack = [] -%}

{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="local") -%}


{#- ----------------------------------------------------------------------- -#}
{#-  two deepcopy macros                                                    -#}
{#- ----------------------------------------------------------------------- -#}


{#- -#}
{#- below is a macro that uses recursion -#}
{#- best recursion example I have seen -#}
{#- https://stackoverflow.com/questions/44816903/recursively-find-child-items-and-list-in-jinja -#}
{#- -#}
{#- also, to understand how recursion is implemented in jinja2, with the idea of the loop variable -#}
{#- see https://jinja.palletsprojects.com/en/3.1.x/templates/#for, and search for "recursive" -#}
{#- -#}
{#- further on the technical side of the implementation, I believe that using a stack is not -#}
{#- required, but we'll see this later; for now this works -#}
{#- -#}
{#- so this function/macro createItemCopy: we need this macro in order to make deep copies of -#}
{#- json objects, ie dict or mappings in jinja2 lingo:  -#}
{#- indeed, jinja2 accesses vars by reference only: a statement like -#}
{#- set var = object  -#}
{#- does not create a (local) copy of the object, but only a link -#}
{#- -#}
{#- therefore, anytime we need to create a new json object, we must do a deepcopy  -#}
{#- hence this macro which must use recursion in order to cater for all cases -#}
{#- -#}
{#- the resulting copy is to be found as the only elt (left) in global_ns.var_stack -#}
{%- macro createItemCopy(object) -%}

  {%- if object is mapping -%}
    {%- set local_ns.var_mapping = {} -%}
    {#- we use the stack to push a new object/mapping -#}
    {%- do global_ns.var_stack.append(local_ns.var_mapping) -%}

    {%- for key, value in object.items() recursive -%}   {#- the outer recursive loop starts here -#}
      {%- set outer_loop = loop -%}                      {#- for mappings  -#}

      {%- if value is string or value is number -%} 
        {%- do global_ns.var_stack[global_ns.var_stack|length - 1].update( { key : value }) -%}
        {#- base case -#}

      {%- elif value is none -%}
        {%- do global_ns.var_stack[global_ns.var_stack|length - 1].update( { key : none }) -%}
        {#- base case -#}

      {%- elif value is mapping -%}
        {%- set local_ns.var_mapping_2 = {} -%}
        {#- we use the stack to push a new object/mapping -#}
        {%- do global_ns.var_stack.append(local_ns.var_mapping_2) -%}
        
        {{ loop(value.items()) }}
        {#- all values in mapping have been seen -#}
        {#- we can update key, value, and pop the last stack item {...} -#}

        {#- {{ "stack before pop {} " ~ global_ns.var_stack }} -#}
        {#- we have finished processing the object/mapping var_mapping_2  -#}
        {#- we can pop it  -#}
        {%- set var_mapping = global_ns.var_stack.pop() -%} 
        {#- {{ "stack after pop {} " ~ global_ns.var_stack }} -#}
        {%- do global_ns.var_stack[global_ns.var_stack|length - 1].update( { key : var_mapping }) -%} 
        {#- base case -#}
        {#- end of mapping -#}

      {%- elif value is sequence -%}
        {%- set local_ns.var_sequence = [] -%}
        {#- we use the stack to push a new object/sequence -#}
        {%- do global_ns.var_stack.append(local_ns.var_sequence) -%}
        {%- for item in value recursive -%} {#- the inner outer recursive loop starts here -#}
          {%- set inner_loop = loop -%}     {#- for sequences  -#}

          {%- if item is mapping -%}
            {%- set local_ns.var_mapping_3 = {} -%}
            {#- we use the stack to push a new object/mapping -#}
            {%- do global_ns.var_stack.append(local_ns.var_mapping_3) -%}

            {{ outer_loop(item.items()) }}

            {#- {{ "stack before pop {} " ~ global_ns.var_stack }} -#}
            {#- we have finished processing the object/mapping var_mapping_3 -#}
            {#- we can pop it  -#}
            {%- set var_mapping = global_ns.var_stack.pop() -%} 
            {#- {{ "stack after pop {} " ~ global_ns.var_stack }} -#}
            {%- do global_ns.var_stack[global_ns.var_stack|length - 1].append(var_mapping) -%} 
            {#- base case -#}
            {#- end of mapping -#}
            
          {%- elif item is string or value is number -%}
            {%- do global_ns.var_stack[global_ns.var_stack|length - 1].append(item) -%}
          {%- elif item is sequence -%}
            {%- set local_ns.var_sequence_2 = [] -%}
            {#- we use the stack to push a new object/sequence -#}
            {%- do global_ns.var_stack.append(local_ns.var_sequence_2) -%}

            {{ inner_loop(item.items()) }}
            
            {#- {{ "stack before pop {} " ~ global_ns.var_stack }} -#}
            {#- we have finished processing the object/sequence var_sequence_2 -#}
            {#- we can pop it  -#}
            {%- set var_sequence = global_ns.var_stack.pop() -%} 
            {#- {{ "stack after pop {} " ~ global_ns.var_stack }} -#}
            {%- do global_ns.var_stack[global_ns.var_stack|length - 1].append(var_sequence) -%} 
            {#- base case -#}
            {#- end of mapping -#}
            
          {%- endif -%}
        {%- endfor -%}   {#- all values in sequence have been seen to -#}

        {#- {{ "stack before pop [] " ~ global_ns.var_stack }} -#}
        {#- we have finished processing the object/sequence var_sequence -#}
        {#- we can pop it  -#}
        {%- set var_sequence = global_ns.var_stack.pop() -%} 
        {#- {{ "stack after pop [] " ~ global_ns.var_stack }} -#}
        
        {%- do global_ns.var_stack[global_ns.var_stack|length - 1].update( { key :  var_sequence }) -%}
        {#- base case -#}
     {%- endif -%} {#- end of sequence -#}

    {%- endfor -%}  {#- all key, values in mapping have been seen to -#}
     {#- {{ "stack after recursive " ~ global_ns.var_stack }} -#}
  {%- endif -%}

  {#- there is now one element left in  global_ns.var_stack -#}
  {#- it is local_ns.var_mapping which was pushed first thing in the macro  -#}

{%- endmacro -%}




{%- macro deepCopy(entity) -%}

  {{ createItemCopy(entity) }}

  {#- at this stage, global_ns.var_stack|length must be one  -#}
  {#- otherwise, something went badly wrong.... -#}
  {%- if global_ns.var_stack|length != 1  -%}
    {{ "in deepCopy problem with stack length != 1, length is " ~ global_ns.var_stack|length }}
    {{ "in deepCopy stack " ~  global_ns.var_stack }}
    {#- jinja2 cannot raise errors, so we must find a way round this -#}
    {#- without crashing the lot of course -#}
    {#- need to think.... -#}
  {%- else -%}
    {#- we do nothing here: the copy will be retrieved by the calling function -#}
    {#- -#}
    {#- so note, after each call to createItemCopy() the result is the (only) element -#}
    {#- in the stack -#}
  {%- endif -%}

{%- endmacro -%}


{#- ----------------------------------------------------------------------- -#}
{#-  checking if a (uuid) path is a subset of another (uuid) path           -#}
{#- ------------------------------- --------------------------------------- -#}


{#- this macro will test if a uuid path 'path', typically referring -#}
{#- to a questions/answer, is a superset of another path  objectPath -#}
{#- -#}
{#- to put it in a different way, the question is: does entity -#}
{#- belong to the object referred to by objectPath? -#}
{#- -#}
{#- this is relevant when seeking to ascertain that a given answer -#}
{#- refers to a particular object: a case in point are objects that -#}
{#- are ItemList questions: -#}
{#- to which item (there may be more than one) does an answer belong to?  -#}
{%- macro checkEntityPartOfObject(objectPath, path) -%}
  {#- given the way paths are constructed, if entity is part of object -#}
  {#- the sequence of uuids in objectPath MUST be present as the starting -#}
  {#- sequence (a prefix) in path  -#}
  {#- -#}
  {#- this would mean that we would have to check that -#}
  {#- for i in 0..objectPath|length-1 -#}
  {#-    path[i] == objectPath[i] -#}
  {#- -#}
  {#- however, given the uniqueness of uuids in the context of this KM, -#}
  {#- it is enough to check that -#}
  {#- path[objectPath|length-1] -#} 
  {#-              == objectPathpath[objectPath|length-1] -#} 
  
  {%- if not objectPath -%}
    {%- do global_ns.var_stack.append(false) -%}
    {{ warningMessage(false, "in checkEntityPartOfObject, objectPath is null") }}
  {%- elif not path -%}
    {%- do global_ns.var_stack.append(false) -%}
    {{ warningMessage(false, "in checkEntityPartOfObject, path is null") }}
  {%- else -%}

    {%- set object_path_uuids_list = objectPath.split('.') -%}
    {%- set entity_path_uuids_list = path.split('.') -%}

    {%- set l = object_path_uuids_list|length - 1 -%}
    {%- if entity_path_uuids_list|length < object_path_uuids_list|length  -%}
      {%- do global_ns.var_stack.append(false) -%}
      {{ warningMessage(false, "in checkEntityPartOfObject, path is shorter than objectPath") }}
    {%- elif object_path_uuids_list[l] == entity_path_uuids_list[l]  -%}
      {%- do global_ns.var_stack.append(true) -%}
    {%- else -%}   
      {%- do global_ns.var_stack.append(false) -%}
    {%- endif -%}
  {%- endif -%}

{%- endmacro -%}








{#- ----------------------------------------------------------------------- -#}
{#-  a warning or error message           -#}
{#- ------------------------------- --------------------------------------- -#}
{%- macro warningMessage(warning, str) -%}
  {%- if warning  -%}
    {{ "\nWARNING   " ~ str }}
  {%- else -%}
    {{ "\nERROR   " ~ str }}
  {%- endif -%}
{%- endmacro -%}



{#- ----------------------------------------------------------------------- -#}
{#-  a string manipulation macro           -#}
{#- ------------------------------- --------------------------------------- -#}
{#- to clean strings with spaces, accents... non alphanum chars -#}
{%- set global_ns.alpha_num = [ "a", "b", "c", "d", "e", "f", "g", "h", "i", "j",
"k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x",
"y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B",
"C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P",
"Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "_" ] -%}
{%- set global_ns.num = [ "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"] -%}

{%- macro cleanVarName(str) -%} 

  {%- set local_ns = namespace(description=none) -%}
  
  {%- set local_ns.varName = str|string|trim|replace(" ","_") -%}

  {%- set local_ns.varName = local_ns.varName|replace("é","e") -%}
  {%- set local_ns.varName = local_ns.varName|replace("è","e") -%}
  {%- set local_ns.varName = local_ns.varName|replace("ê","e") -%}

  {%- set local_ns.varName = local_ns.varName|replace("á","a") -%}
  {%- set local_ns.varName = local_ns.varName|replace("à","a") -%}
  {%- set local_ns.varName = local_ns.varName|replace("â","a") -%}

  {%- set local_ns.varName = local_ns.varName|replace("í","i") -%}
  {%- set local_ns.varName = local_ns.varName|replace("ì","i") -%}
  {%- set local_ns.varName = local_ns.varName|replace("î","i") -%}

  {%- set local_ns.varName = local_ns.varName|replace("ó","o") -%}
  {%- set local_ns.varName = local_ns.varName|replace("ô","o") -%}
  {%- set local_ns.varName = local_ns.varName|replace("ò","o") -%}
  
  {%- set local_ns.varName = local_ns.varName|replace("ú","u") -%}
  {%- set local_ns.varName = local_ns.varName|replace("ù","u") -%}
  {%- set local_ns.varName = local_ns.varName|replace("û","u") -%}

  {%- set local_ns.varName = local_ns.varName|replace("È","E") -%}
  {%- set local_ns.varName = local_ns.varName|replace("É","E") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Ê","E") -%}

  {%- set local_ns.varName = local_ns.varName|replace("À","A") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Á","A") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Â","A") -%}

  {%- set local_ns.varName = local_ns.varName|replace("Í","I") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Ì","I") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Î","I") -%}

  {%- set local_ns.varName = local_ns.varName|replace("Ó","O") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Ô","O") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Ò","O") -%}
  
  {%- set local_ns.varName = local_ns.varName|replace("Ú","U") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Ù","U") -%}
  {%- set local_ns.varName = local_ns.varName|replace("Û","U") -%}

  {%- set local_ns.varName = local_ns.varName|replace("ç","c") -%}

  {%- for i in range(local_ns.varName|length) -%}
    {%- set c = local_ns.varName[i] -%} 
    {%- if c in global_ns.alpha_num -%}
      {#- do nothing -#}
    {%- else -%}
        {%- set local_ns.varName = local_ns.varName|replace(c, "_") -%}
    {%- endif -%}
  {%- endfor -%}

  {%- if local_ns.varName[0] in num -%}
    {%- set varName = "n_" ~ local_ns.varName -%}
    {%- set local_ns.varName = varName -%}
  {%- endif -%}
  
  {%- do global_ns.var_stack.append(local_ns.varName) -%}

{%- endmacro -%}



{%- set global_ns.YNU_FR = ["Oui", "Non", "Non connu"]  -%}
{%- set global_ns.YNU_EN = ["yes", "no", "unknown"]  -%}


{%- macro getControlledVocabularyTermYNU(str) -%}
  {%- if str and str in global_ns.YNU_FR -%}
    {%- do global_ns.var_stack.append(global_ns.YNU_EN[global_ns.YNU_FR.index(str)]) -%}
  {%- else -%}
    {%- do global_ns.var_stack.append("unknown")  -%}
  {%- endif  -%}
{%- endmacro -%}




{#- ----------------------------------------------------------------------- -#}
{#-  dataset and distribution selection based on names and other params        -#}
{#- ----------------------------------------------------------------------- -#}


{%- macro getDatasetNames(entity, all_listed_names, message, reply) -%}
  {%- set concerned_names = []  -%}

  {%- set name_list = reply.split(',') -%}
  {%- if name_list|length == 0  -%}
    {{ warningMessage(true, "No dataset names were given in  " ~ message ~ " question \"" ~ entity.title ~ "\"") }}
  {%- else -%}
    {%- for name in name_list -%}
      {%- set name = name|trim -%}
      {%- if name in all_listed_names -%}
        {%- do concerned_names.append(name) -%}
      {%- elif name in ["tous", "toutes", "tout"] -%}
        {#- all are concerned -#}
        {%- for n in all_listed_names -%}
          {%- do concerned_names.append(n) -%}
        {%- endfor -%}
      {%- else -%}
        {{ warningMessage(true, "In " ~ message ~ " question \"" ~ entity.title ~ "\", the name given \"" ~ name ~ "\" cannot be found in the list of datasets") }}
      {%- endif -%}
    {%- endfor -%}
  {%- endif -%}

  {%- do global_ns.var_stack.append(concerned_names)  -%}
{%- endmacro -%}



{%- macro getSiteTitles(globals) -%}
  {#- a note of caution:  all distribution identification actually originates -#}
  {#- from physical infrastructure details asked at the very beginning of the -#}
  {#- questionnaire -#}
  {#- this could well be not optimal: a question for end-users, which might -#}
  {#- necessitate a questionnaire modification -#}

  {#- I have to write this function because my knowledge of jinja2 filtering is too shallow... -#}

  {%- set distribution_vars = globals.global_ns.distribution_vars  -%}
  {%- set sites = distribution_vars.infrastructure_sites -%}
  {%- set nb_sites = sites|length -%}

  {%- set site_titles = [] -%}
  {%- if nb_sites > 0 -%}
    {%- for i in range(nb_sites) -%}
      {%- do site_titles.append(sites[i].title) -%}
    {%- endfor -%}
  {%- else -%}
    {%- do site_titles.append(distribution_vars.infrastructure_title) -%}
  {%- endif -%}

  {%- do global_ns.var_stack.append(site_titles)  -%}
{%- endmacro -%}


{%- macro getPhysicalSiteTitles(entity, globals, message, reply)  -%}

  {{ getSiteTitles(globals) }}
  {%- set all_site_titles = global_ns.var_stack.pop()  -%}
  {%- set concerned_sites = []  -%}
  
  {%- set site_title_list = [] -%}
  {%- if reply -%}
    {%- set site_title_list = reply.split(',') -%}
  {%- endif -%}

  {%- if site_title_list|length == 0  -%}
    {#- here, if there is no answer, we take all sites into account -#}
    {%- for title in all_site_titles -%}
      {%- do concerned_sites.append(title) -%}
    {%- endfor -%}
  {%- else -%}
    {%- for site in site_title_list -%}
      {%- set title = site|trim -%}
      {%- if title in all_site_titles -%}
        {%- do concerned_sites.append(title) -%}
      {%- elif title in ["tous", "toutes", "tout"] -%}
        {#- all are concerned -#}
        {%- for t in all_site_titles -%}
          {%- do concerned_sites.append(t) -%}
        {%- endfor -%}
      {%- else -%}
        {{ warningMessage(true, "In " ~ message ~ " question \"" ~ entity.title ~ "\", the title given \"" ~ title ~ "\" cannot be found in the list of sites") }}
      {%- endif -%}
    {%- endfor -%}
  {%- endif -%}

{#-  {{ "\nreply " ~ reply ~ " sites " ~ concerned_sites ~ "\n" }}  -#}

  {%- do global_ns.var_stack.append(concerned_sites)  -%}
{%- endmacro -%}




{%- macro getAllDatasets(dmp_being_built) -%}
  {%- set datasets = []  -%}
  {%- for dataset in dmp_being_built.dataset -%}
    {% do datasets.append(dataset) -%}
  {%- endfor -%}
  {%- do global_ns.var_stack.append(datasets)  -%}
{%- endmacro -%}

{%- macro getDatasetTitlesFromName(globals, dmp_being_built, name)  -%}
  {#- given names of the dataset, the map dataset_titles_map, we return all titles for the name -#}
  {%- set all_listed_names = globals.global_ns.dataset_vars.name_list -%}
  {%- set dataset_titles_map = globals.global_ns.dataset_vars.map_name_titles -%}
  {%- set dataset_titles = []  -%}

  {%- set index = all_listed_names.index(name)  -%}
  {%- for title in dataset_titles_map[index] -%}
    {#- recall that title is unique -#}
    {%- do dataset_titles.append(title) -%}
  {%- endfor -%}

  {%- do global_ns.var_stack.append(dataset_titles)  -%}
{%- endmacro -%}


{%- macro getDatasetsFromName(globals, dmp_being_built, name)  -%}
  {#- given names of the dataset, the map dataset_titles_map, we return all datasets of interest -#}

  {%- set datasets = []  -%}

  {{ getDatasetTitlesFromName(globals, dmp_being_built, name) }}
  {%- set dataset_titles = global_ns.var_stack.pop() -%}
  {%- for title in dataset_titles -%}
    {#- recall that title is unique -#}
    {%- set dataset = dmp_being_built.dataset|selectattr("title", "==", title)|list -%}
    {%- do datasets.append(dataset[0]) -%}
  {%- endfor -%}

  {%- do global_ns.var_stack.append(datasets)  -%}
{%- endmacro -%}


{%- macro getDatasetsFromNames(globals, dmp_being_built, name_list)  -%}
  {#- given names of the dataset, the map dataset_titles_map, we return all datasets of interest -#}
  {%- set all_datasets = []  -%}
  
  {%- for name in name_list -%}
    {{ getDatasetsFromName(globals, dmp_being_built, name) }} 
    {%- set datasets = global_ns.var_stack.pop() -%}
    {%- for dataset in datasets  -%}
      {%- do all_datasets.append(dataset) -%}
    {%- endfor -%}
  {%- endfor -%}

  {%- do global_ns.var_stack.append(all_datasets)  -%}
{%- endmacro -%}

{%- macro getDatasetsFromNameAndDiscipline(globals, dmp_being_built,  
  discipline_title, name)  -%}
  {%- set all_listed_names = globals.global_ns.dataset_vars.name_list -%}
  {%- set dataset_titles_map = globals.global_ns.dataset_vars.map_name_titles -%}
  {%- set datasets = []  -%}

  {%- set index = all_listed_names.index(name)  -%}
  {%- for title in dataset_titles_map[index] -%}
    {#- recall that title is unique -#}
    {%- if title == discipline_title -%}
      {%- set dataset = dmp_being_built.dataset|selectattr("title", "==", title)|list -%}
      {%- do datasets.append(dataset[0]) -%}
    {%- endif -%}
  {%- endfor -%}

  {%- do global_ns.var_stack.append(datasets)  -%}
{%- endmacro -%}

{%- macro getDatasetsFromNamesAndDisciplines(globals, dmp_being_built,  
  discipline_title_list, name_list)  -%}
  {#- given names of the dataset, the map dataset_titles_map, we return all datasets of interest -#}
  {%- set all_listed_names = globals.global_ns.dataset_vars.name_list -%}
  {%- set dataset_titles_map = globals.global_ns.dataset_vars.map_name_titles -%}
  {%- set all_datasets = []  -%}

  {%- for name in name_list -%}
    {%- for discipline_title in discipline_title_list -%}
      {{ getDatasetsFromNameAndDiscipline(globals, dmp_being_built,  
  discipline_title, name) }}
      {%- set datasets = global_ns.var_stack.pop() -%}
      {%- for dataset in datasets  -%}
        {%- do all_datasets.append(dataset) -%}
      {%- endfor -%}
    {%- endfor -%}
  {%- endfor -%}

  {%- do global_ns.var_stack.append(all_datasets)  -%}
{%- endmacro -%}




{%- macro getDistributionsFromSiteItem(globals, dmp_being_built, distribution_site_item) -%}
  {#- given a globals.global_ns.distribution_site_item, we return all distributions of interest -#}

  {%- set dataset_name = distribution_site_item.dataset_name -%}
  {%- set site_title = distribution_site_item.site_title -%}
  {%- set distributions = []  -%}

  {{ getDatasetsFromName(globals, dmp_being_built, dataset_name) }}
  {%- set datasets = global_ns.var_stack.pop() -%}
  {%- for dataset in datasets -%}
    {%- for distribution in dataset.distribution -%}
      {%- if distribution.title == site_title -%}
        {%- do distributions.append(distribution) -%}
      {%- endif -%}
    {%- endfor -%}
  {%-endfor -%}

  {%- do global_ns.var_stack.append(distributions)  -%}
{%- endmacro -%}

{%- macro getDistributionsFromSiteItems(globals, dmp_being_built, distribution_site_item_list) -%}
  {#- given a list of globals.global_ns.distribution_site_item, we return all distributions of interest -#}

  {%- set all_distributions = []  -%}
  
  {%- for site_item in distribution_site_item_list -%}
    {{ getDistributionsFromSiteItem(globals, dmp_being_built, site_item) }}
    {%- set distributions = global_ns.var_stack.pop() -%}
    {%- for distribution in distributions -%}
      {%- do all_distributions.append(distribution) -%}
    {%- endfor -%}
  {%- endfor -%}

  {%- do global_ns.var_stack.append(all_distributions)  -%}
{%- endmacro -%}

{%- macro getAllDistributions(dmp_being_built) -%}
  {%- set all_distributions = []  -%}

  {{ getAllDatasets(dmp_being_built) }}
  {%- set datasets = global_ns.var_stack.pop() -%}
  {%- for dataset in datasets -%}
    {%- for distribution in dataset.distribution -%}
      {%- do all_distributions.append(distribution) -%}
    {%- endfor -%}
  {%- endfor -%}
  
  {%- do global_ns.var_stack.append(all_distributions)  -%}
{%- endmacro -%}

{%- macro siteItemExistsInList(site_item_list, site_item) -%}
  {%- set local_ns.answer = false -%}
  {%- for item in site_item_list -%}
    {% if site_item.dataset_name == item.dataset_name and site_item.site_title == item.site_title -%}
      {% set local_ns.answer = true -%}
    {%- endif -%}
  {%- endfor -%}
  {%- do global_ns.var_stack.append(local_ns.answer) -%}
{%- endmacro -%}


{%- macro addSiteItemToSiteItemList(site_item_list, site_item) -%}
  {{ siteItemExistsInList(site_item_list, site_item) }}
  {%- set answer = global_ns.var_stack.pop() -%}
  {%- if not answer -%}
    {%- do site_item_list.append(site_item) -%}
  {%- endif -%}
{%- endmacro -%}



 




